<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="../style.css" type="text/css">
<link rel="icon" type="image/png" href="icon.png">
<title>Why I switched to OpenBSD</title>
<body>
<h1>azarus' page</h1>
<h2>Why I switched to OpenBSD</h2>
<p>Date: 2017-12-26</p>
<p>I've always had a thing for simple, concise and readable software. In fact, my
favourite pieces of software are from <a href="https://suckless.org">the suckless
project</a>, especially <a href="https://st.suckless.org">st, the terminal
emulator</a> and <a href="https://dwm.suckless.org">dwm, the dynamic window
manager.</a>

<p>Now, I've grown rather disappointed in the Linux desktop. The few remaining
somewhat "sane" distros (Gentoo, Artix, Void) are good, but they still don't
really make me all that happy anymore. Lacklustre/bad documentation for common
programs (*don't* get me started on `info`), bloated GNU utilities everywhere,
and the whole philosophy doesn't appeal to me anymore. The Linux kernel grows
everyday, with code of rather questionable quality. And userspace isn't looking
good, either. We have PulseAudio, systemd, glibc becoming somewhat necessary for
a normal desktop. One can always use alternatives, like I did for a while, with
just plain ALSA, OpenRC and musl libc, but it just becomes a constant hassle to
be fixing everything all the time. For example, 
<a href="http://www.omgubuntu.co.uk/2017/03/firefox-52-no-sound-pulseaudio-alsa-linux">
Firefox dropped ALSA support</a> and it left me either installing a
compatibility shim, called
<a href="https://github.com/i-rinat/apulse">apulse</a>, or completely migrating
to PulseAudio, which I'd really rather not!</p>

<p>After quite some consideration, I decided to give the *BSDs a try. First, I
tried FreeBSD, and
<a href="https://cooltrainer.org/a-freebsd-desktop-howto/">here's</a> a great
guide for the FreeBSD desktop. FreeBSD has quite some neat features, like
native ZFS, jails and bhyve! I read through most of the
<a href="https://www.freebsd.org/doc/handbook/book.html">FreeBSD handbook</a>,
fixed some issues in the German translation, and installed it on one of my spare
SSDs on my trusty, corebooted X230. It was quite nice, and just about everything
worked without too much tinkering (I was suprised!), but there were some minor
niggles, like fiddly WiFi (which wasn't a complete deal-breaker for me).</p>

<p>And as such, I decided to give OpenBSD a go. OpenBSD's philosophy appeals to
me very strongly. They believe in strong security, and their aspiration is to be
the *number one* in the industry for security. They also believe in full
disclosure, frequent source code audits, and they make frequent
<a href="https://www.openbsd.org/innovations.html">security innovations</a> they
are the source of programs that I can barely live without
(<a href="https://www.openssh.com/">OpenSSH</a> and
<a href="https://github.com/tmux/tmux/wiki">tmux</a> are notable examples).
After installing the most recent OpenBSD snapshot with full disk encryption on
my laptop, I was positively amazed. Up-to-date versions of all the software I
use were available as binary packages, networking was a piece of cake to setup
(a failover bridge with my wired and wireless interface allows me to never miss
a packet when I dock and undock my laptop), documentation was delightful
(actually useful manpages), xenocara (the OpenBSD fork of X.org) worked without
any tweaking, my games worked (emulators are available for almost every console)
all the suckless software I have compiled without any hiccups and the community
was very helpful if I had any issues and they have the same affinity for simple,
secure software that I have.</p>

<p>Yesterday, I switched my VPS (from which you're reading this page) to OpenBSD
as well. It took some tweaking to work from my VPS provider, but it was worth
it.  Prosody (the XMPP server I'm using) works just as well on OpenBSD as it
does on Linux, and OpenBSD httpd is a perfect fit for this website. It's small,
simple, secure by default, and easy to configure.</p>

<p>The only machine I haven't switched over is my main desktop computer. The
reasons I haven't are that OpenBSD doesn't yet have good drivers for my AMD GPU,
and that <a href="https://winehq.org">Wine</a> doesn't work on OpenBSD.</p>
	<footer>
	<hr>
	<p>Unless otherwise noted, this content is <a href="https://creativecommons.org/publicdomain/zero/1.0/">
	publicly licensed (CC0)</a>.</p>
	<p>This website is served by the <a href="https://man.openbsd.org/httpd">httpd</a> daemon, running on OpenBSD 6.3.</p>
	</footer>
</body>
</html>
